from pymongo import MongoClient

class DBModel:

	client = MongoClient()

	def insert_cleaning_data(self, database, collection, documents):
		db = self.client[database]
		db[collection].drop()
		results = db[collection].insert_many(documents.to_dict('records'))

		return results.inserted_ids

	def insert_header(self, database, collection, documents):
		db = self.client[database]
		db[collection].drop()
		results = db[collection].insert(documents)

		return results

	def get_data_all(self, database, collection):
		db = self.client[database]
		cursor = db[collection].find({})

		return cursor

	def get_data_limit(self, database, collection, documents):
		db = self.client[database]
		colom="Sentiment"
		cursor = db[collection].find({colom:documents}).limit(50)

		return cursor

	def insert_many(self, database, collection, documents):
		db = self.client[database]
		db[collection].drop()
		results = db[collection].insert_many(documents.to_dict('records'))

		return results.inserted_ids

	def insert_one(self, database, collection, documents):
		db = self.client[database]
		results = db[collection].insert(documents)

		return results

	def drop_collection(self, database, collection):
		db = self.client[database]
		results = db[collection].drop()

		return results

	def insert_sentence_result(self, database, collection, document):
		result = {}
		db = self.client[database]
		results=db[collection].insert(document)
			
		return result

	def get_data_count(self, database, collection,document):
		db = self.client[database]
		colom="Sentiment"
		cursor = db[collection].find({colom:document}).count()

		return cursor

	

	def get_data_sentiment(self, database, collection, sentiment):
		db = self.client[database]
		cursor = db[collection].aggregate(
		    [
		      {"$project": {"IdTweet":"$IdTweet",
		      				"IdAccount":"$IdAccount",
		      				"Username":"$Username",
							"ScreenName":"$ScreenName",
							"TweetText":"$TweetText",
							"TweetTextClean":"$TweetTextClean",
							"Sentiment":"$Sentiment",
							"TweetTime":"$getTanggal",
							"label":"$label",
							"LocationCoordinates":"$LocationCoordinates",
							"LocationPlace":"$LocationPlace",
							"Mention":"$Mention",
							"Hashtag":"$Hashtag",
							"Keywords":"$Keywords",
							"RelatedKeywords":"$RelatedKeywords",
							"Entities":"$Entities",
							"LinksContained":"$LinksContained",
							"RetweetFrom":"$RetweetFrom",
							"RetweetTweetID":"$RetweetTweetID",
							"TweetEnggagement":"$TweetEnggagement",
							"ReplyOfTweetScreenName":"$ReplyOfTweetScreenName",
							"ReplyOfTweetId":"$ReplyOfTweetId",
							"ReplyOfTweetText":"$ReplyOfTweetText",
							"TweetUrl":"$TweetUrl",
							"getTanggal": { "$dateToString": { "format": "%Y-%m-%d", "date": "$TweetTime" } }}},
		      { "$match" : { "Sentiment" : sentiment } }
		    ]
		)
		return cursor
	