import json
import pymongo
import string
import nltk

from app import app
from flask import Response, Blueprint, request, render_template
from gensim import corpora, models
from collections import Counter

mod_ft_frequent_topic = Blueprint('ft_frequent_topic', __name__, url_prefix='/ft_frequent_topic/<collectionflag>')

@mod_ft_frequent_topic.route('', methods = ['GET'])
def ft_frequent_topic(collectionflag):
    myclient = pymongo.MongoClient("mongodb://localhost:27017/")
    mydb = myclient["test_median_app"]
    mycol = mydb[collectionflag]
    
    list_of_list_of_tokens = list()
    for text in mycol.find({}, {"_id": 0, "TweetTextClean": 1}):
        tokens = nltk.word_tokenize(text['TweetTextClean'])
        list_of_list_of_tokens.append(tokens)

    dictionary_LDA = corpora.Dictionary(list_of_list_of_tokens)
    dictionary_LDA.filter_extremes(no_below=3)
    corpus = [dictionary_LDA.doc2bow(list_of_tokens) for list_of_tokens in list_of_list_of_tokens]

    num_topics = 20
    lda_model = models.LdaModel(corpus, num_topics=num_topics, \
                                id2word=dictionary_LDA, \
                                passes=4, alpha=[0.01]*num_topics, \
                                eta=[0.01]*len(dictionary_LDA.keys()))

    keywordlist = list()
    keywordgrouplist = list()
    for topic in lda_model.show_topics(formatted=True, num_topics=num_topics, num_words=5):
        topiclist = topic[1].split(" + ")
        keywoddstrlist = list()
        for topicitem in topiclist:
            topicelement = topicitem.split("*")
            keywoddstrlist.append(str.replace(topicelement[1],'"',''))
            list_of_topic_item = list(int((float(topicelement[0])*1000))*(str.replace(topicelement[1],'"',''),))
            keywordlist = keywordlist + list_of_topic_item
        keywordgrouplist.append(', '.join(keywoddstrlist))

    keyword_tupl_list = Counter(keywordlist)
    topicformat = list()
    for keyword in keyword_tupl_list:
        topicformat.append({'text':keyword, 'size':int(keyword_tupl_list[keyword])})
    
    js = json.dumps([keywordgrouplist, topicformat])
    resp = Response(js, status=200, mimetype='application/json')
    return resp