from flask import Blueprint, request, render_template, jsonify, json
from app import app
import subprocess
import os

mod_twitter_instance_crawl = Blueprint('twitter_instance_crawl', __name__, url_prefix='/mod_twitter_instance_crawl')
mod_instagram_instance_crawl = Blueprint('instagram_instance_crawl', __name__, url_prefix='/mod_instagram_instance_crawl')
mod_kill_instance_crawl = Blueprint('kill_instance_crawl', __name__, url_prefix='/mod_kill_instance_crawl')

dbname = app.config["DBNAME"]

@mod_twitter_instance_crawl.route('/<collection_name>/<keywords>/', defaults = {'startdate':None, 'enddate':None}, methods=['GET'])
#URL : http://127.0.0.1:5000/mod_twitter_instance_crawl/papuabebas/papua-bebas/2019-05-01/2019-09-10/
@mod_twitter_instance_crawl.route('/<collection_name>/<keywords>/<startdate>/<enddate>/', methods=['GET'])
#URL : http://127.0.0.1:5000/mod_twitter_instance_crawl/papuabebas/papua-bebas/
def twitter_instance_crawl(collection_name=None, keywords=None, startdate=None, enddate=None):
	temp_key = keywords.split("-")
	frase = '"'
	temp_key_frase = list(filter(lambda x: frase in x, temp_key)) 
	qoute_replace = [w.replace('"', '%22') for w in temp_key_frase]
	space_replace = [w.replace(' ', '%20') for w in qoute_replace]
	key_frase = "%20OR%20".join(space_replace)

	temp_key_not_frase = list(filter(lambda x: frase not in x, temp_key))
	temp_key_not_frase = [w.replace('#', '%23') for w in temp_key_not_frase]

	key_not_frase = "%20OR%20".join(temp_key_not_frase)

	if temp_key_frase != "" and temp_key_not_frase != "":
		key = "{}%20({})".format(key_frase, key_not_frase)
	elif temp_key_frase != "" and temp_key_not_frase == "":
		key = key_frase
	else:
		key = key_not_frase

	if(startdate and enddate):
		url = "https://mobile.twitter.com/search?q={}%20lang%3Aid%20until%3A{}%20since%3A{}&src=typed_query".format(key, enddate, startdate)
	else:
		url = "https://mobile.twitter.com/search?q={}%20lang%3Aid&src=typed_query".format(key)
	
	os.system("./run_spider.sh {} {} {} '{}' &".format("twitter_mobile_crawl", dbname, collection_name, url))

	return "run instance crawl {}".format(collection_name)

@mod_instagram_instance_crawl.route('/<collection_name>/<keywords>', methods=['GET'])
#URL : http://127.0.0.1:5000/mod_instagram_instance_crawl/papuabebas/papua-bebas/
def instagram_instance_crawl(collection_name=None, keywords=None):
	temp_key = keywords.split("-")
	for key in temp_key:
		url = "https://www.instagram.com/explore/tags/{}".format(key)
		command = "./run_spider.sh {} {} {} '{}'".format("instagram_crawl", dbname, collection_name, url)
		proc = subprocess.Popen([command], shell=True,
             stdin=None, stdout=None, stderr=None, close_fds=True)
		# os.system("./run_spider.sh {} {} {} {}".format("instagram_crawl", dbname, collection_name, url))


	return "run instance crawl {}".format(collection_name)

@mod_kill_instance_crawl.route('/<collection_name>/', methods=['GET'])
#URL : http://127.0.0.1:5000/mod_kill_instance_crawl/papuabebas/
def twitter_kill_instance_crawl(collection_name=None):
	command = "ps -A | grep 'collection=%s' | awk '{print $1}' | xargs killall -9 $1"%(collection_name)
	os.system(command)
	proc = subprocess.Popen([command], shell=True,
             stdin=None, stdout=None, stderr=None, close_fds=True)
	os.system("pkill -f {}".format(collection_name))
	return "crawl {} was killed".format(collection_name)