from flask import Blueprint, request, render_template, jsonify, json
from app.models import dbmodel_popularity_entity as d 
from app import app

import random

mod_stream_popularity_entities = Blueprint('stream_popularity_entities', __name__, url_prefix='/mod_stream_popularity_entities')
mod_instance_popularity_entities = Blueprint('instance_popularity_entities', __name__, url_prefix='/mod_instance_popularity_entities')

dbname = app.config["DBNAME"]

@mod_stream_popularity_entities.route('/<collection_name>', methods=['GET'])
def popularity_stream(collection_name):
	collection = "{}_popularity_entities".format(collection_name)
	dbmodel = d.DBModel()
	data = dbmodel.get_data_all_stream(dbname, collection)

	return data

@mod_instance_popularity_entities.route('/<collection_name>', methods=['GET'])
def popularity_instance(collection_name):
	collection = "{}_popularity_entities".format(collection_name)
	dbmodel = d.DBModel()
	data = dbmodel.get_data_all_instance(dbname, collection)

	return data