from app import app
from flask import Response

import json
import pymongo

@app.route('/')
@app.route('/sc_network_thenets/<collectionflag>', methods = ['GET'])
def sc_network_thenets(collectionflag):
    myclient = pymongo.MongoClient("mongodb://localhost:27017/")
    mydb = myclient["median"]
    mycol = mydb[collectionflag] #twitter_00012019051701
    
    nodesCandidate = list()
    links = list()
    for x in mycol.find({},{"_id": 0, "Username": 1, "RetweetFrom": 1}):
        if x["RetweetFrom"] is not None:
            nodesCandidate.append(x["Username"])
            nodesCandidate.append(x["RetweetFrom"])
            links.append(dict([("source", x["Username"]),("target", x["RetweetFrom"]),("value", 1)]))
    
    nodesCandidate = list(dict.fromkeys(nodesCandidate))
    nodes = list()
    for item in nodesCandidate:
        nodes.append(dict([("id", item),("group", 1)]))
    
    data = dict([("nodes", nodes),("links", links)])
    js = json.dumps(data)
    resp = Response(js, status=200, mimetype='application/json')
    return resp
    
@app.route('/sc_network_cluster_ratio/<collectionflag>', methods = ['GET'])
def sc_network_cluster_ratio(collectionflag):
    data = [{'name': 'Cluster 1', 'y': 60}, {'name': 'Cluster 2','y': 40}, {'name': 'Cluster 3','y': 20}]
    js = json.dumps(data)
    resp = Response(js, status=200, mimetype='application/json')

    return resp