from flask import Blueprint, request, render_template, jsonify, json, Response
from openpyxl import load_workbook
from collections import Counter
from app.models import dbmodel_viewsentiment as d

import string
import pandas as pd

mod_viewsentiment = Blueprint('viewsentiment', __name__, url_prefix='/mod_viewsentiment/<collection>')
mod_ratiosentiment = Blueprint('ratiosentiment', __name__, url_prefix='/mod_ratiosentiment/<collection>')
mod_trendsentiment = Blueprint('trendsentiment', __name__, url_prefix='/mod_trendsentiment/<collection>')

dbmodel = d.DBModel()
database="test_median_app"
#collection="twitter_00012019070302_se"
@mod_viewsentiment.route('', methods=['POST','GET'])
def viewsentiment(collection):
	
	# get table to mongodb
	
	getDataCleaningPos = dbmodel.get_data_limit(database, collection,"positif")
	getDataCleaningNeg = dbmodel.get_data_limit(database, collection,"negatif")
	getDataCleaningNet = dbmodel.get_data_limit(database, collection,"netral")
	dat=[]
	for datax in getDataCleaningPos:
		# print(datax["Username"])
		data = {'TweetText'  : datax['TweetText'], 'Sentiment' : datax['Sentiment'], 'Username' : datax['Username'], 'TweetEnggagement' : datax['TweetEnggagement']}
		dat.append(data)

	for datax in getDataCleaningNeg:
		# print(datax["Username"])
		data = {'TweetText'  : datax['TweetText'], 'Sentiment' : datax['Sentiment'], 'Username' : datax['Username'], 'TweetEnggagement' : datax['TweetEnggagement']}
		dat.append(data)

	for datax in getDataCleaningNet:
		# print(datax["Username"])
		data = {'TweetText'  : datax['TweetText'], 'Sentiment' : datax['Sentiment'], 'Username' : datax['Username'], 'TweetEnggagement' : datax['TweetEnggagement']}
		dat.append(data)

	js=json.dumps(dat)
	return Response(js, status=200, mimetype='application/json')


@mod_ratiosentiment.route('', methods=['POST','GET'])
def ratiosentiment(collection):
	
	# get table to mongodb
	getDataPositif = dbmodel.get_data_count(database, collection,"positif")
	getDataNegatif = dbmodel.get_data_count(database, collection,"negatif")
	getDataNetral = dbmodel.get_data_count(database, collection,"netral")


	data = {'positif'  : getDataPositif, 'negatif' : getDataNegatif, 'netral' : getDataNetral}

	js=json.dumps(data)
	return Response(js, status=200, mimetype='application/json')

@mod_trendsentiment.route('', methods=['POST','GET'])
def trendsentiment(collection):
	
	# get table to mongodb
	getDataPositif = dbmodel.get_data_sentiment(database, collection,"positif")
	getDataNegatif = dbmodel.get_data_sentiment(database, collection,"negatif")
	getDataNetral = dbmodel.get_data_sentiment(database, collection,"netral")

	data_netral=[]
	for datas in getDataNetral:
		data = {'TweetTime'  : datas['getTanggal'], 'Sentiment' : datas['Sentiment']}
		data_netral.append(data)

	netral = Counter()
	for item in data_netral:
	    netral[item["TweetTime"]] += 1

	data_negatif=[]
	for datas in getDataNegatif:
		data = {'TweetTime'  : datas['getTanggal'], 'Sentiment' : datas['Sentiment']}
		data_negatif.append(data)

	negatif = Counter()
	for item in data_negatif:
	    negatif[item["TweetTime"]] += 1

	data_positif=[]
	for datas in getDataPositif:
		data = {'TweetTime'  : datas['getTanggal'], 'Sentiment' : datas['Sentiment']}
		data_positif.append(data)

	positif = Counter()
	for item in data_positif:
	    positif[item["TweetTime"]] += 1


	data=list(positif.keys()) + list(negatif.keys())+ list(netral.keys())
	data_tanggal=(list(set(data)))
	tanggal_data=sorted(data_tanggal)

	sentiment_pos={}
	for tanggal in tanggal_data:
		if tanggal in positif.keys():
			sentiment_pos[tanggal]=positif[tanggal]
		else:
			sentiment_pos[tanggal]=0

	sentiment_neg={}
	for tanggal in tanggal_data:
		if tanggal in negatif.keys():
			sentiment_neg[tanggal]=negatif[tanggal]
		else:
			sentiment_neg[tanggal]=0

	sentiment_net={}
	for tanggal in tanggal_data:
		if tanggal in netral.keys():
			sentiment_net[tanggal]=netral[tanggal]
		else:
			sentiment_net[tanggal]=0

	data_trend=[list(sentiment_net.keys()),[["postitif", list(sentiment_pos.values())],["negatif",list(sentiment_neg.values())],["netral",list(sentiment_net.values())]]]

	js=json.dumps(data_trend)
	return Response(js, status=200, mimetype='application/json')
