import scrapycrawl.dbmodel_popularity_entities as d
import random

def popular_entity_instance(db, collection, data):
    """ Popularity Entity """
    dbmodel = d.DBModel()
    field_x = "Mention.screen_name"
    field_y = "RetweetFrom"
    field_tweet = "TweetText"

    ori_collection = collection
    collection_entity_popularity = "{}_popularity_entities".format(collection)
    collection_count_unique_tweet = "{}_count_unique_tweet".format(collection)
    check_collection_unique_tweet = dbmodel.check_collection_exists(db, collection_count_unique_tweet)

    for akun in data['Mention']:
        tweet_exists = dbmodel.check_tweet_unique_exists(db, collection_count_unique_tweet, data["TweetText"], akun["screen_name"])
        # print("Tweet popular : ", data["TweetText"], "Account : ", akun["screen_name"])
        # print("collection : ", check_collection_unique_tweet, "tweet_exists : ",tweet_exists)
        if check_collection_unique_tweet and tweet_exists:
        #update when exist tweet
            dbmodel.update_count_unique_tweet(db, collection_count_unique_tweet, data["TweetText"], akun["screen_name"])
        else:
        #insert apabila tweet belum ada dalam unique tweet
            data_tweet = {}
            data_tweet["TweetText"] = data["TweetText"]
            data_tweet["Account"] = akun["screen_name"]
            data_tweet["Count"] = 1
            dbmodel.insert_one(db, collection_count_unique_tweet, data_tweet)

    # =========== belum mencari popularity ==================
        data_dict = {}
        colors=["indigo","orange","teal","skyblue","crimson","lime","green","yellow","blue"]
        data_dict["account"] = akun["screen_name"] #aktor
        data_dict["count_of_tweet"] = dbmodel.count_of_tweet(db, ori_collection, field_x, akun["screen_name"]) #banyaknya tweet
        data_dict["count_of_mention"] = dbmodel.counting_mention(db, ori_collection, field_x, akun["screen_name"]) #banyaknya mention
        data_dict["counting_retweet_from_mention"] = dbmodel.counting_repost(db, ori_collection, field_x, field_y, akun["screen_name"]) #banyaknya retweet
        data_dict["sum_of_mention_and_retweet_from_mention"] = data_dict["count_of_mention"]+data_dict["counting_retweet_from_mention"] #popularitas
        data_dict["color"] = random.choice(colors) #random colors
        popular_tweet = dbmodel.findMostPopularTweet(db, collection_count_unique_tweet, field_x, akun["screen_name"]) #isi tweet yang paling populer
        
        if len(popular_tweet) <= 0:
            data_dict["tweet"] = data["TweetText"]
        else:
            data_dict["tweet"] = popular_tweet["TweetText"]

        check = dbmodel.check_duplicate_key(db, collection_entity_popularity, "account", akun["screen_name"])
        if check >= 1:
            entity_data = dbmodel.update_popularity(db, collection_entity_popularity, akun["screen_name"], data_dict)
        else:
            entity_data = dbmodel.insert_one(db, collection_entity_popularity, data_dict)