from scrapy.spiders import Spider
from scrapy.http.request import Request
from scrapy.selector import Selector
from scrapycrawl.items import TweetmobileItem
from scrapycrawl.items import InstagramItem
from w3lib.html import remove_tags
import requests
import json
from datetime import datetime
import re
from scrapy.conf import settings
import json
import tweet_preprocess

class TwitterSpider(Spider):
	index = 0
	name = "twitter_mobile"
	allowed_domains = ["mobile.twitter.com"]
	custom_settings = {
        'ITEM_PIPELINES': {
            'scrapycrawl.pipelines.TweetmobilePipeline' : 0,
        }
    }

	# start_urls = [
	# 	"https://mobile.twitter.com/search?q=coca%20cola&src=typed_query"
	# ]

	""" start crawling from console
		scrapy crawl twitter_mobile -a url="https://mobile.twitter.com/search?q=coca%20cola&src=typed_query 
		run.run_crawl("hehe","https://mobile.twitter.com/search?q=coca%20cola&src=typed_query") """


	def __init__(self, url='https://mobile.twitter.com/search?q=', *args, **kwargs):
	    # Don't forget to call parent constructor
	    super(TwitterSpider, self).__init__(*args, **kwargs)
	    # Set the start_urls to be the one given in url parameters
	    self.start_urls = [url]

	def unique(self, data):
		# print(dict.fromkeys(data))
		return list(set(dict.fromkeys(data)))


	def tweet_preprocess_equipment(self):
	    oovFile = open("resources/oov_list.csv", 'r')
	    oovList = [line.replace('\n', '').split(',') for line in oovFile.readlines()]

	    dictFile = open("resources/dictionary.txt", 'r')
	    dictList = [line.replace('\r\n','') for line in dictFile.readlines()]
	    
	    return oovList, dictList
	
	def parse(self, response):
		s = Selector(response)
		next_link = s.xpath('//div[@class="w-button-more"]/a/@href').extract()
		if len(next_link):
			yield Request("https://mobile.twitter.com"+next_link[0], callback=self.parse)
		itemselector = Selector(response).xpath('//*[@id="main_content"]/div/div[3]/table')
		now = datetime.now()
		data_dict = {}

		oovList, dictList = self.tweet_preprocess_equipment()

		for sel in itemselector:
			self.index += 1
			item = TweetmobileItem()
			item['index'] = self.index
			item['idTweet'] = ''.join(
				map(str.strip, sel.xpath('tr[2]/td/div/@data-id').extract()))
			item['idAccount'] = None
			item['Username'] = ''.join(
				map(str.strip, sel.xpath('tr[1]/td[2]/a/div/text()').extract()))
			#item['url'] = ''.join(
			#	map(str.strip, sel.xpath('tr[3]/td/span[1]/a/@href').extract()))
			item['Screenname'] = None
			ori_tweet = remove_tags(''.join(
				map(str.strip, sel.xpath('tr[2]/td/div').extract()))).replace('  ','').replace('\n','')

			tweet = ori_tweet.replace('&amp','&').replace('\n      ','').replace('\n    ','')
			item['TweetText'] = ori_tweet
			text_content_clean = tweet_preprocess.preprocessing(ori_tweet, oovList, dictList)
			item['TweetTextClean'] = u''+tweet
			time = ''.join(
				map(str.strip, sel.xpath('tr[1]/td[3]/a/text()').extract()))
			last_char = time[-1:]
			if last_char == "h" or last_char == "m" or last_char == "s":
				item['TweetTime'] = now.strftime("%b %d")
			else:
				item["TweetTime"] = time
			
			item['LocationCoordinates'] = None
			item['LocationPlace'] = None

			# mention
			catch_mention = re.findall(r"(@\S+)", tweet)
			mention = [i for i in catch_mention if i != ""]
			temp_list_mention = []
			unique_mention = self.unique(mention)
			for m in unique_mention:
				temp_dict_mention = {}
				temp_dict_mention['screen_name'] = m
				temp_list_mention.append(temp_dict_mention)
			item['Mention'] = temp_list_mention

			# hashtag
			catch_hashtag = re.findall(r"(#\S+)", tweet)
			hashtag = [i for i in catch_hashtag if i != ""]
			temp_list_hashtag = []
			unique_hashtag = self.unique(hashtag)
			for h in unique_hashtag:
				temp_dict_hashtag = {}
				temp_dict_hashtag['text'] = h
				temp_list_hashtag.append(temp_dict_hashtag)
			item['Hastag'] = temp_list_hashtag


			item['Keyword'] = None
			item['RelatedKeywords'] = None
			item['Entities'] = None
			item['LinkContained'] = None
			item['RetweetFrom'] = None
			item['RetweetTweetID'] = None
			item['TweetEnggagement'] = [0,0]
			item['ReplyOfTweetScreenName'] = None
			item['ReplyOfTweetId'] = None
			item['ReplyOfTweetText'] = None
			sentiment = tweet_preprocess.get_sentiment(text_content_clean)
			item['Sentiment'] = sentiment
			item['TweetUrl'] = "https://mobile.twitter.com/{}/status/{}".format(item['Username'],item['idTweet'])

			yield item

class InstagramSpider(Spider):
    index = 0
    name = "instagram"
    allowed_domains = ["instagram.com"]
    main_url = ""
    custom_settings = {
        'ITEM_PIPELINES': {
            'scrapycrawl.pipelines.InstagramPipeline' : 0,
        }
    }
    """ start crawling from console
    scrapy crawl twitter_mobile -a url="https://mobile.twitter.com/search?q=coca%20cola&src=typed_query """

    def __init__(self, url=None, *args, **kwargs):
        # Don't forget to call parent constructor
        super(InstagramSpider, self).__init__(*args, **kwargs)
        # Set the start_urls to be the one given in url parameters
        self.start_urls = [url]
        global main_url
        main_url = url

    def unique(self, data):
            return list(dict.fromkeys(data))

    def getIdandLocation(self, response):
        # print("data request",response.body)
        # username = json.loads(response.body)
        item = response.meta['item']
        data =  json.loads(response.body)
        item['username'] = data["graphql"]["shortcode_media"]["owner"]["username"]
        item['location'] = data["graphql"]["shortcode_media"]["location"]
        return [item]

    def parse(self, response):
        selector = Selector(response)
        data_komentar = []
        check_next_page = ''.join(str(s) for s in self.crawler.engine.slot.inprogress)
        
        if "?__a=1&max_id=" in check_next_page:
            item = json.loads((response.body).decode("utf-8"))
            data_source = item['graphql']['hashtag']['edge_hashtag_to_media']
            page_info = data_source['page_info']

        else:
            item = selector.xpath("/html/body/script[1]/text()").extract()
            data_selector = re.findall('window._sharedData = (.*);', item[0])
            data = json.loads(data_selector[0])
     
            data_source = data['entry_data']['TagPage'][0]['graphql']['hashtag']['edge_hashtag_to_media']
            page_info = data_source['page_info']

        has_next_page = page_info['has_next_page']
        end_cursor = page_info['end_cursor']

        if has_next_page and end_cursor:
            yield Request("{}?__a=1&max_id={}".format(main_url, end_cursor), callback=self.parse)

        for post in data_source['edges']:
            self.index += 1
            item = InstagramItem()
            item['index'] = self.index
            item['idPost'] = post['node']['shortcode']
            item['idAccount'] = post['node']['owner']['id']
            # url = "https://i.instagram.com/api/v1/users/{}/info/".format(item['idAccount'])
            url = "https://www.instagram.com/p/{}/?__a=1".format(item['idPost'])
            response = requests.get(url)
            data_requests = json.loads(response.content)
            item['Username'] = data_requests["graphql"]["shortcode_media"]["owner"]["username"]
            #item['url'] = ''.join(
            #   map(str.strip, sel.xpath('tr[3]/td/span[1]/a/@href').extract()))
            item['PostContent'] = post['node']['edge_media_to_caption']['edges'][0]['node']['text']
            item['PostContentClean'] = ""

            waktu = datetime.utcfromtimestamp(post['node']['taken_at_timestamp']).strftime('%Y-%m-%d %H:%M:%S')

            item['PostTime'] = waktu
            item['Location'] = data_requests["graphql"]["shortcode_media"]["location"]
            #item['countLike'] = post['node']['edge_liked_by']
            # mention
            item['Mention'] = ""
            # hashtag
            catch_hashtag = re.findall(r"(#\S+)", item['PostContent'])
            hashtag = [i for i in catch_hashtag if i != ""]
            item['Hashtag'] = self.unique(hashtag)
            item['TaggedAccount'] = ""

            item['Keyword'] = ""
            item['RelatedKeywords'] = ""
            item['Entities'] = ""
            item['LinksContained'] = ""
            item['RepostFrom'] = ""
            item['Enggagement'] = ""
            item['Sentimen'] = ""
            item['postURL'] = "https://www.instagram.com/p/{}".format(post['node']['shortcode'])

            yield item