import re, sys
import string
import difflib
import preprocessor
import pickle
import numpy as np

from sklearn.feature_extraction.text import CountVectorizer
from sklearn.feature_extraction.text import TfidfTransformer
from sklearn.pipeline import Pipeline
from sklearn.naive_bayes import GaussianNB
from nltk.tokenize import sent_tokenize
from sklearn.svm import LinearSVC
from sklearn.multiclass import OneVsRestClassifier, OneVsOneClassifier

from nltk.tokenize import word_tokenize
from Sastrawi.Stemmer.StemmerFactory import StemmerFactory
from Sastrawi.StopWordRemover.StopWordRemoverFactory import StopWordRemoverFactory, StopWordRemover, ArrayDictionary

def removePunctuation(str):
    remove = string.punctuation
    remove = remove.replace("-", "") # don't remove hyphens
    remove = remove.replace("'", "")
    pattern = r"[{}]".format(remove)
    return re.sub(pattern, " ", str)
    
def removeStopword(str):
    stop_factory = StopWordRemoverFactory().get_stop_words()
    more_stopword = ['dan', 'yg', 'ini', 'dengan', 'to', 'itu', 'dari', 'ada', 'dalam', 'is', 'ga', 'ya', 'ke', 'el', 'the']
     
    # Merge stopword
    data = stop_factory + more_stopword
    dictionary = ArrayDictionary(data)
    stoprmv = StopWordRemover(dictionary)
 
    return stoprmv.remove(str)
    
def stemming(str):
    factory = StemmerFactory()
    stemmer = factory.create_stemmer()
    stemmed = stemmer.stem(str)   
    return stemmed
    
def lenghten(text, txtList):
	token = word_tokenize(text)
	norm = list()

	for word in token:
		for a,b in txtlist:
			if word == a:
				word = b
		norm.append(word)
	fix = ' '.join(norm)
	return fix
		
def shorten(sentence, dictList):	
	token = word_tokenize(sentence)
	stList = list()
	for text in token:
		dictShortList = [x for x in dictList if x.startswith(text[0])]
		theword, val = text, 0		
		for target in dictShortList:
			temp = difflib.SequenceMatcher(None, target, text)
			if temp.ratio() >  val :
				val = temp.ratio()
				theword = target
		stList.append(theword)		
	stSentence = ' '.join(stList)
	return stSentence
    
def preprocessing(str, oovList, dictList):
    new_string = preprocessor.clean(str)
    new_string = removePunctuation(new_string)
    new_string = new_string.lower()
    new_string = removeStopword(new_string)
     #new_string = stemming(new_string)
			
    return new_string
    
def detect_retweet(str):
    token = word_tokenize(str)
    if(token[0] == 'RT'):
        return token[2]
    else:
        return None
        
def get_sentiment(sentence):
    f = open("model_sentiment.pikcle", 'rb')
    text_clf = pickle.load(f)
    line = []
    line.append(sentence)
    predicted = text_clf.predict(np.asarray(line))
    for i in range(len(predicted)):
        if(predicted[i]==0):
            sentiment_result='netral'
        elif(predicted[i]==1):
            sentiment_result='positif'
        elif(predicted[i]==2):
            sentiment_result='negatif'
    return sentiment_result